<?php 
global $gallery;

require('check_init.php'); 
require("config.php"); 

// Include rest of init that is required to load up albums

$GALLERY_MODULENAME = "gallery";
$GALLERY_BASEDIR = XOOPS_ROOT_PATH.'/modules/xoopsgallery/';
$GALLERY_URL = XOOPS_URL . '/modules/xoopsgallery/';
$GALLERY_EMBEDDED_INSIDE = 'xoops2';

/* Load classes and session information */
require($GALLERY_BASEDIR . "util.php");
require($GALLERY_BASEDIR . "classes/Album.php");
require($GALLERY_BASEDIR . "classes/Image.php");
require($GALLERY_BASEDIR . "classes/AlbumItem.php");
require($GALLERY_BASEDIR . "classes/AlbumDB.php");
require($GALLERY_BASEDIR . "classes/User.php");
require($GALLERY_BASEDIR . "classes/EverybodyUser.php");
require($GALLERY_BASEDIR . "classes/NobodyUser.php");
require($GALLERY_BASEDIR . "classes/LoggedInUser.php");
require($GALLERY_BASEDIR . "classes/UserDB.php");
require($GALLERY_BASEDIR . "classes/Comment.php");

if (!$GALLERY_NO_SESSIONS) {
    require($GALLERY_BASEDIR . "session.php");
}

include($GALLERY_BASEDIR . "classes/xoops2/UserDB.php");
include($GALLERY_BASEDIR . "classes/xoops2/User.php");

/* Load our user database (and user object) */
$gallery->userDB = new Xoops_UserDB;

if ((is_object($GLOBALS['xoopsUser']) && (get_class($GLOBALS['xoopsUser']) == "xoopsuser")) || isset($_SESSION['gallery_user'])) {
	if (isset($_SESSION['gallery_user'])) 
		$gallery->session->username = $_SESSION['gallery_user'];
	else
		$gallery->session->username = $GLOBALS['xoopsUser']->getVar('uname'); 

	$gallery->user = $gallery->userDB->getUserByUsername($gallery->session->username);
}

echo "<h1>"._MD_GALLERY_ADMIN_TABLECHECK_TITLE."</h1>\n";
echo "<p>"._MD_GALLERY_ADMIN_TABLECHECK_DESC."</p>\n";

$FixErrors = (isset($_POST["FixErrors"]));
$FoundErrors = false;
$albumDB = new AlbumDB(FALSE);
$albumList = Array();
$gallery->session->albumName = "";
$numAlbums = $albumDB->numAlbums($gallery->user);
$numPhotos = $albumDB->getCachedNumPhotos($gallery->user);

// Grab all image records from XOOPS database
$image_handler =& xoops_getmodulehandler('image');
$album_images =& $image_handler->getObjects(null, true);

// Function to recursively get all children album names
function getChildren($albumName) {
	global $gallery;
	$myAlbumList = Array();
	$myAlbum = new Album();
	$myAlbum->load($albumName);
	$numPhotos = $myAlbum->numPhotos(1);
	for ($i=1; $i <= $numPhotos; $i++) {
		if ($myAlbum->isAlbumName($i)) {
			$myName = $myAlbum->isAlbumName($i);
			$myAlbumList = array_merge($myAlbumList, Array($myName), getChildren($myName));
		}
	}
	return $myAlbumList;
}

// Pre-scan to build full list of albums
for ($i = 1; $i <= $numAlbums; $i++) {

	$gallery->album = $albumDB->getAlbum($gallery->user, $i);
	$isRoot = $gallery->album->isRoot(); // Only display album if it is a root album
	if ($isRoot) {
		$tmpAlbumName = $gallery->album->fields["name"];
		$albumList = array_merge($albumList, $tmpAlbumName, getChildren($tmpAlbumName));
	}
}

$numAlbums = count($albumList);
echo _MD_GALLERY_ADMIN_TABLECHECK_TOTALCHECK.": $numAlbums<br />\n";

while (list($i, $chkAlbumName) = each ($albumList)) {

	$chkAlbum = new Album();
	$chkAlbum->load($chkAlbumName);
	$chkAlbumURL = makeAlbumUrl($chkAlbumName);
	$chkAlbumDir = $chkAlbum->getAlbumDir();
	$chkAlbumFoundErrors = false;
	$numPhotos = $chkAlbum->numPhotos(1);
	echo "<br /><br />"._MD_GALLERY_ADMIN_TABLECHECK_CHECKING." <a href=\"$chkAlbumURL\">$chkAlbumName</a> (".($i+1)." "._MD_GALLERY_ADMIN_TABLECHECK_OF." $numAlbums, $numPhotos "._MD_GALLERY_ITEMS.")<br />";

	for ($j = 1; $j <= $numPhotos; $j++) {
		$chkPhotoID = $chkAlbum->getPhotoId($j);
		$chkPhoto =& $chkAlbum->getPhoto($j); // Reference so you don't just get a copy of the info
		if (!$chkPhoto->isMovie() && !$chkPhoto->getIsAlbumName()) {
			echo "<br /> &nbsp;"._MD_GALLERY_ADMIN_TABLECHECK_CHECKING.": ".$chkPhoto->getCaption()."<br />";
		
			// Check this photo for proper records in the image table
			$xoops_imageid = $chkPhoto->image->getXoopsImageId();
			echo " &nbsp;&nbsp;&nbsp;"._MD_GALLERY_ADMIN_TABLECHECK_ORIGINAL." ";
			if (isset($album_images[$xoops_imageid])) {
				$isOK = _MD_GALLERY_ADMIN_TABLECHECK_OK." ($xoops_imageid) ";
			} else {
				$isOK = _MD_GALLERY_ADMIN_TABLECHECK_MISSING." ($xoops_imageid) ";
				$FoundErrors = true;
				$chkAlbumFoundErrors = true;
				if ($FixErrors) {
					$isOK .= " "._MD_GALLERY_ADMIN_TABLECHECK_CORRECTING."... ";
					$xoops_imageid = $chkPhoto->image->setXoopsImageData($chkAlbumDir);
					$isOK .= _MD_GALLERY_ADMIN_TABLECHECK_NEWID.": $xoops_imageid ";
				}
			}
			echo _MD_GALLERY_ADMIN_TABLECHECK_ORIGINAL." $isOK<br />\n";
			
			// Check Thumbnail too
			$xoops_imageid = $chkPhoto->thumbnail->getXoopsImageId();
			echo " &nbsp;&nbsp;&nbsp;"._MD_GALLERY_ADMIN_TABLECHECK_THUMB." ";
			if (isset($album_images[$xoops_imageid])) {
				$isOK = _MD_GALLERY_ADMIN_TABLECHECK_OK." ($xoops_imageid) ";
			} else {
				$isOK = _MD_GALLERY_ADMIN_TABLECHECK_MISSING." ($xoops_imageid) ";
				$FoundErrors = true;
				$chkAlbumFoundErrors = true;
				if ($FixErrors) {
					$isOK .= " "._MD_GALLERY_ADMIN_TABLECHECK_CORRECTING."... ";
					$xoops_imageid = $chkPhoto->thumbnail->setXoopsImageData($chkAlbumDir);
					$isOK .= _MD_GALLERY_ADMIN_TABLECHECK_NEWID.": $xoops_imageid ";
				}
			}
			echo _MD_GALLERY_ADMIN_TABLECHECK_THUMB." $isOK<br />\n";
		}
	}
	if ($chkAlbumFoundErrors && $FixErrors) {
		$saveOK = $chkAlbum->save();
		echo "<br /> &nbsp;"._MD_GALLERY_ADMIN_TABLECHECK_SAVING.": ";
		if ($saveOK = true) {
			echo _MD_GALLERY_ADMIN_TABLECHECK_OK;
		} else {
			echo _MD_GALLERY_ADMIN_TABLECHECK_ERROR;
		}
		echo "<br /><br />";
	}	
}

If ($FoundErrors && !$FixErrors) {
	echo '<h3>'._MD_GALLERY_ADMIN_TABLECHECK_ERRORSFOUND.'</h3>
		<form action="index.php" method="POST">
		<input type="hidden" name="op" value="check_missing">
		<input type="submit" name="FixErrors" value="'._MD_GALLERY_ADMIN_TABLECHECK_FIXERRORS.'">
		</form>';
} elseif ($FoundErrors) {
	echo '<h3>'._MD_GALLERY_ADMIN_TABLECHECK_FIXEDERRORS.'</h3>';
} else {
	echo '<h3>'._MD_GALLERY_ADMIN_TABLECHECK_NOERRORS.'</h3>';
}	
?>